# Emogle script
# Author : ashtaroth, asht4roth, depends if someone steals my nick on efnet
# Feel free to modify
# Please email any mods/suggestions to eikcam@gmail.com

# Version History
# 1.0      - Initial coding.
# End of Version History

package require http

putlog "Emogle TCL v0.1 loaded"

set CHAT(id) ""
set CHAT(chan) ""
set CHAT(end) 0
set CHAT(online) 0
set CHAT(connected) 0
set CHAT(nick) ""

bind pub -|- !chat chat_start
bind pub -|- $ chat_send
bind pub -|- !disconnect chat_disconnect 

proc chat_start {nick host handle chan text} {
	global CHAT
	set CHAT(chan) $chan
	if {$CHAT(online) == 1} {
		putserv "PRIVMSG $CHAT(chan) :Chat is already in progress..."
	} else {
		set CHAT(online) 1
		set CHAT(end) 0
		set CHAT(nick) $nick
		set url "http://omegle.com/start"
		set token [::http::geturl $url -query " "]
		set stuff [::http::data $token]
		set id [string trim $stuff '"']
		set CHAT(id) $id
		putserv "PRIVMSG $chan :Chat connecting..."
		chat_event $id $CHAT(chan)
	}
}

proc chat_event {id chan} {
	set url "http://omegle.com/events"
	set token [::http::geturl $url -query "id=$id" -command httpCallback]]
}

proc chat_send {nick host handle chan text} {
	global CHAT
	if {$CHAT(online) == 1} {
		if {$CHAT(connected) == 1} {
				set url "http://omegle.com/send"
				set token [::http::geturl $url -query "msg=$text&id=$CHAT(id)" -command httpCallback]]
		} else {
		putserv "PRIVMSG $CHAT(chan) :Chat is still connecting..."
		}
	} else {
		putserv "PRIVMSG $CHAT(chan) :No chat available. Type !chat"
	}
}

proc chat_disconnect {nick host handle chan text} {
	global CHAT
	if {$CHAT(online) == 1} {
		set CHAT(end) 1
		set CHAT(online) 0
		set CHAT(connected) 0
		set url "http://omegle.com/disconnect"
		set token [::http::geturl $url -query "id=$CHAT(id)"]
		putserv "PRIVMSG $CHAT(chan) :You disconnected!"
	} else {
		putserv "PRIVMSG $CHAT(chan) :No chat available. Type !chat"
	}
}

proc httpCallback {token} {
	global CHAT
	set stuff [::http::data $token]
	set results [regexp -all -inline -linestop -lineanchor {\[".*?"\]} $stuff]
		
	foreach test $results {
		if {$CHAT(end) == 1} {break}
		regexp -linestop -lineanchor {"([a-zA-Z]*)"} $test action action_clean
		
		switch $action_clean {
			"waiting" {
				putserv "PRIVMSG $CHAT(chan) :Looking for a stranger..."
			}
			"connected" {
				set CHAT(connected) 1
				putserv "PRIVMSG $CHAT(chan) :Connected! 'Hi' is auto sent."
				set url "http://omegle.com/send"
				set token [::http::geturl $url -query "msg=hi&id=$CHAT(id)" -command httpCallback]]
			}
			#"typing" {
			#	putserv "PRIVMSG $CHAT(chan) :Stranger is typing..."
			#}
			"gotMessage" {
				regexp -all -linestop -lineanchor {\["(.*)", "(.*)"\]} $test msg_orig msg_code msg_text
				putserv "PRIVMSG $CHAT(chan) :Stranger: [string trim $msg_text]"
			}
			"strangerDisconnected" {
				set CHAT(end) 1
				set CHAT(online) 0
				set CHAT(connected) 0
				putserv "PRIVMSG $CHAT(chan) :The stranger disconnected!"
			}
		}
	}
	if {$CHAT(end) == 0} {
		chat_event $CHAT(id) $CHAT(chan)
	}	
}